/* PolkitDialog.c generated by valac 0.46.1, the Vala compiler
 * generated from PolkitDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */

#include <granite.h>
#include <glib-object.h>
#include <glib.h>
#include <polkitagent/polkitagent.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>

#define AG_WIDGETS_TYPE_POLKIT_DIALOG (ag_widgets_polkit_dialog_get_type ())
#define AG_WIDGETS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog))
#define AG_WIDGETS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))
#define AG_WIDGETS_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))

typedef struct _AgWidgetsPolkitDialog AgWidgetsPolkitDialog;
typedef struct _AgWidgetsPolkitDialogClass AgWidgetsPolkitDialogClass;
typedef struct _AgWidgetsPolkitDialogPrivate AgWidgetsPolkitDialogPrivate;
enum  {
	AG_WIDGETS_POLKIT_DIALOG_0_PROPERTY,
	AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* ag_widgets_polkit_dialog_properties[AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL,
	AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS
};
static guint ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS] = {0};

struct _AgWidgetsPolkitDialog {
	GraniteMessageDialog parent_instance;
	AgWidgetsPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgWidgetsPolkitDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _AgWidgetsPolkitDialogPrivate {
	PolkitAgentSession* pk_session;
	PolkitIdentity* pk_identity;
	GCancellable* cancellable;
	gulong error_signal_id;
	gulong request_signal_id;
	gulong info_signal_id;
	gulong complete_signal_id;
	GList* idents;
	gchar* cookie;
	gboolean canceling;
	GtkRevealer* feedback_revealer;
	GtkLabel* password_label;
	GtkLabel* password_feedback;
	GtkEntry* password_entry;
	GtkComboBox* idents_combo;
};

static gint AgWidgetsPolkitDialog_private_offset;
static gpointer ag_widgets_polkit_dialog_parent_class = NULL;

GType ag_widgets_polkit_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AgWidgetsPolkitDialog, g_object_unref)
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_new (const gchar* message,
                                                     const gchar* icon_name,
                                                     const gchar* _cookie,
                                                     GList* _idents,
                                                     GCancellable* _cancellable);
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_construct (GType object_type,
                                                           const gchar* message,
                                                           const gchar* icon_name,
                                                           const gchar* _cookie,
                                                           GList* _idents,
                                                           GCancellable* _cancellable);
static void ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                               gpointer self);
static void ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void __lambda5_ (AgWidgetsPolkitDialog* self);
static void ___lambda5__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static gboolean ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                                  GdkEventKey* key);
static gboolean _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self);
static void _ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                        gpointer self);
static void ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_real_show (GtkWidget* base);
static void ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                                const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                                 const gchar* text,
                                                                                 gpointer self);
static void ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                       gboolean authorized);
static void _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                       gboolean gained_authorization,
                                                                                       gpointer self);
static void ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                             const gchar* request,
                                             gboolean echo_on);
static void _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                           const gchar* request,
                                                                           gboolean echo_on,
                                                                           gpointer self);
static void ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                               const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                               const gchar* text,
                                                                               gpointer self);
static void ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_finalize (GObject * obj);

static inline gpointer
ag_widgets_polkit_dialog_get_instance_private (AgWidgetsPolkitDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AgWidgetsPolkitDialog_private_offset);
}

static void
_ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                          gpointer self)
{
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
}

static void
_ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
	ag_widgets_polkit_dialog_on_ident_changed ((AgWidgetsPolkitDialog*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda5_ (AgWidgetsPolkitDialog* self)
{
	ag_widgets_polkit_dialog_cancel (self);
}

static void
___lambda5__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda5_ ((AgWidgetsPolkitDialog*) self);
}

static void
_ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	ag_widgets_polkit_dialog_authenticate ((AgWidgetsPolkitDialog*) self);
}

static gboolean
_ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self)
{
	gboolean result;
	result = ag_widgets_polkit_dialog_on_key_release ((AgWidgetsPolkitDialog*) self, event);
	return result;
}

static void
_ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                   gpointer self)
{
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
}

AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_construct (GType object_type,
                                    const gchar* message,
                                    const gchar* icon_name,
                                    const gchar* _cookie,
                                    GList* _idents,
                                    GCancellable* _cancellable)
{
	AgWidgetsPolkitDialog * self = NULL;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkRevealer* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkLabel* _tmp16_;
	GtkComboBox* _tmp17_;
	GtkComboBox* _tmp18_;
	GtkComboBox* _tmp19_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRendererPixbuf* _tmp20_;
	GtkComboBox* _tmp21_;
	GtkCellRenderer* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkCellRenderer* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkCellRenderer* _tmp26_;
	GtkComboBox* _tmp27_;
	GtkCellRenderer* _tmp28_;
	GtkComboBox* _tmp29_;
	GtkCellRenderer* _tmp30_;
	GtkComboBox* _tmp31_;
	GtkGrid* credentials_grid = NULL;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkGrid* _tmp37_;
	GtkEntry* _tmp38_;
	GtkGrid* _tmp39_;
	GtkRevealer* _tmp40_;
	GThemedIcon* _tmp41_;
	GThemedIcon* _tmp42_;
	gboolean _tmp43_ = FALSE;
	GtkBin* _tmp47_;
	GtkBin* _tmp48_;
	GtkGrid* _tmp49_;
	GtkButton* cancel_button = NULL;
	GtkWidget* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* authenticate_button = NULL;
	GtkWidget* _tmp52_;
	GtkButton* _tmp53_;
	GtkStyleContext* _tmp54_;
	g_return_val_if_fail (message != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (_cookie != NULL, NULL);
	g_return_val_if_fail (_cancellable != NULL, NULL);
	self = (AgWidgetsPolkitDialog*) g_object_new (object_type, "title", _ ("Authentication Dialog"), NULL);
	self->priv->idents = _idents;
	_tmp0_ = g_strdup (_cookie);
	_g_free0 (self->priv->cookie);
	self->priv->cookie = _tmp0_;
	self->priv->cancellable = _cancellable;
	_tmp1_ = self->priv->cancellable;
	g_signal_connect_object (_tmp1_, "cancelled", (GCallback) _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled, self, 0);
	granite_message_dialog_set_primary_text ((GraniteMessageDialog*) self, _ ("Authentication Required"));
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, message);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	_tmp2_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->password_entry);
	self->priv->password_entry = _tmp2_;
	_tmp3_ = self->priv->password_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
	_tmp4_ = self->priv->password_entry;
	gtk_entry_set_input_purpose (_tmp4_, GTK_INPUT_PURPOSE_PASSWORD);
	_tmp5_ = self->priv->password_entry;
	g_object_set (_tmp5_, "primary-icon-name", "dialog-password-symbolic", NULL);
	_tmp6_ = self->priv->password_entry;
	g_object_set (_tmp6_, "primary-icon-tooltip-text", _ ("Password"), NULL);
	_tmp7_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->password_feedback);
	self->priv->password_feedback = _tmp7_;
	_tmp8_ = self->priv->password_feedback;
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_RIGHT);
	_tmp9_ = self->priv->password_feedback;
	gtk_label_set_max_width_chars (_tmp9_, 40);
	_tmp10_ = self->priv->password_feedback;
	g_object_set (_tmp10_, "wrap", TRUE, NULL);
	_tmp11_ = self->priv->password_feedback;
	gtk_label_set_xalign (_tmp11_, (gfloat) 1);
	_tmp12_ = self->priv->password_feedback;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, GTK_STYLE_CLASS_ERROR);
	_tmp14_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->feedback_revealer);
	self->priv->feedback_revealer = _tmp14_;
	_tmp15_ = self->priv->feedback_revealer;
	_tmp16_ = self->priv->password_feedback;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = (GtkComboBox*) gtk_combo_box_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->idents_combo);
	self->priv->idents_combo = _tmp17_;
	_tmp18_ = self->priv->idents_combo;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
	_tmp19_ = self->priv->idents_combo;
	g_signal_connect_object (_tmp19_, "changed", (GCallback) _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed, self, 0);
	_tmp20_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
	g_object_ref_sink (_tmp20_);
	renderer = (GtkCellRenderer*) _tmp20_;
	_tmp21_ = self->priv->idents_combo;
	_tmp22_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp21_, _tmp22_, FALSE);
	_tmp23_ = self->priv->idents_combo;
	_tmp24_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp23_, _tmp24_, "icon-name", 0);
	_tmp25_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp25_);
	_g_object_unref0 (renderer);
	renderer = (GtkCellRenderer*) _tmp25_;
	_tmp26_ = renderer;
	g_object_set (_tmp26_, "xpad", (guint) 6, NULL);
	_tmp27_ = self->priv->idents_combo;
	_tmp28_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp27_, _tmp28_, TRUE);
	_tmp29_ = self->priv->idents_combo;
	_tmp30_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp29_, _tmp30_, "text", 1);
	_tmp31_ = self->priv->idents_combo;
	gtk_combo_box_set_id_column (_tmp31_, 1);
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp32_);
	credentials_grid = _tmp32_;
	_tmp33_ = credentials_grid;
	gtk_grid_set_column_spacing (_tmp33_, 12);
	_tmp34_ = credentials_grid;
	gtk_grid_set_row_spacing (_tmp34_, 6);
	_tmp35_ = credentials_grid;
	_tmp36_ = self->priv->idents_combo;
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 0, 0, 1, 1);
	_tmp37_ = credentials_grid;
	_tmp38_ = self->priv->password_entry;
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 2, 1, 1);
	_tmp39_ = credentials_grid;
	_tmp40_ = self->priv->feedback_revealer;
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 0, 3, 1, 1);
	_tmp41_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
	_tmp42_ = _tmp41_;
	granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp42_);
	_g_object_unref0 (_tmp42_);
	if (g_strcmp0 (icon_name, "") != 0) {
		GtkIconTheme* _tmp44_;
		_tmp44_ = gtk_icon_theme_get_default ();
		_tmp43_ = gtk_icon_theme_has_icon (_tmp44_, icon_name);
	} else {
		_tmp43_ = FALSE;
	}
	if (_tmp43_) {
		GThemedIcon* _tmp45_;
		GThemedIcon* _tmp46_;
		_tmp45_ = (GThemedIcon*) g_themed_icon_new (icon_name);
		_tmp46_ = _tmp45_;
		granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp46_);
		_g_object_unref0 (_tmp46_);
	}
	_tmp47_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
	_tmp48_ = _tmp47_;
	_tmp49_ = credentials_grid;
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
	_tmp50_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
	_tmp51_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_button_get_type (), GtkButton));
	cancel_button = _tmp51_;
	g_signal_connect_object (cancel_button, "clicked", (GCallback) ___lambda5__gtk_button_clicked, self, 0);
	_tmp52_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Authenticate"), (gint) GTK_RESPONSE_APPLY);
	_tmp53_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_button_get_type (), GtkButton));
	authenticate_button = _tmp53_;
	_tmp54_ = gtk_widget_get_style_context ((GtkWidget*) authenticate_button);
	gtk_style_context_add_class (_tmp54_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	g_signal_connect_object (authenticate_button, "clicked", (GCallback) _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked, self, 0);
	gtk_window_set_default ((GtkWindow*) self, (GtkWidget*) authenticate_button);
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event, self, 0);
	g_signal_connect_object ((GtkDialog*) self, "close", (GCallback) _ag_widgets_polkit_dialog_cancel_gtk_dialog_close, self, 0);
	ag_widgets_polkit_dialog_update_idents (self);
	ag_widgets_polkit_dialog_select_session (self);
	_g_object_unref0 (authenticate_button);
	_g_object_unref0 (cancel_button);
	_g_object_unref0 (credentials_grid);
	_g_object_unref0 (renderer);
	return self;
}

AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_new (const gchar* message,
                              const gchar* icon_name,
                              const gchar* _cookie,
                              GList* _idents,
                              GCancellable* _cancellable)
{
	return ag_widgets_polkit_dialog_construct (AG_WIDGETS_TYPE_POLKIT_DIALOG, message, icon_name, _cookie, _idents, _cancellable);
}

static void
ag_widgets_polkit_dialog_real_show (GtkWidget* base)
{
	AgWidgetsPolkitDialog * self;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkEntry* _tmp4_;
	self = (AgWidgetsPolkitDialog*) base;
	GTK_WIDGET_CLASS (ag_widgets_polkit_dialog_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_TYPE_MESSAGE_DIALOG, GraniteMessageDialog));
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	window = _tmp1_;
	_tmp2_ = window;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (window);
		return;
	}
	_tmp3_ = window;
	gdk_window_focus (_tmp3_, (guint32) GDK_CURRENT_TIME);
	_tmp4_ = self->priv->password_entry;
	gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
	_g_object_unref0 (window);
}

static void
ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self)
{
	GtkListStore* model = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint length = 0;
	gint active = 0;
	gchar* target_user = NULL;
	GList* _tmp1_;
	GtkComboBox* _tmp34_;
	GtkListStore* _tmp35_;
	GtkComboBox* _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, polkit_identity_get_type (), -1);
	model = _tmp0_;
	length = 0;
	active = 0;
	target_user = NULL;
	_tmp1_ = self->priv->idents;
	{
		GList* ident_collection = NULL;
		GList* ident_it = NULL;
		ident_collection = _tmp1_;
		for (ident_it = ident_collection; ident_it != NULL; ident_it = ident_it->next) {
			PolkitIdentity* ident = NULL;
			ident = (PolkitIdentity*) ident_it->data;
			{
				PolkitIdentity* _tmp2_;
				gchar* name = NULL;
				PolkitIdentity* _tmp3_;
				gchar* _tmp4_;
				PolkitIdentity* _tmp5_;
				GtkListStore* _tmp25_;
				GtkTreeIter _tmp26_ = {0};
				GtkListStore* _tmp27_;
				GtkTreeIter _tmp28_;
				const gchar* _tmp29_;
				PolkitIdentity* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
				_tmp2_ = ident;
				if (_tmp2_ == NULL) {
					continue;
				}
				_tmp3_ = ident;
				_tmp4_ = polkit_identity_to_string (_tmp3_);
				name = _tmp4_;
				_tmp5_ = ident;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, polkit_unix_user_get_type ())) {
					struct passwd* pwd = NULL;
					PolkitIdentity* _tmp6_;
					struct passwd* _tmp7_;
					struct passwd* _tmp8_;
					_tmp6_ = ident;
					_tmp7_ = getpwuid ((uid_t) polkit_unix_user_get_uid (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, polkit_unix_user_get_type (), PolkitUnixUser)));
					pwd = _tmp7_;
					_tmp8_ = pwd;
					if (_tmp8_ != NULL) {
						gchar* pw_name = NULL;
						struct passwd* _tmp9_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						const gchar* _tmp13_;
						const gchar* _tmp16_;
						gchar* _tmp17_;
						_tmp9_ = pwd;
						_tmp10_ = _tmp9_->pw_name;
						_tmp11_ = g_strdup (_tmp10_);
						pw_name = _tmp11_;
						_tmp13_ = target_user;
						if (_tmp13_ == NULL) {
							_tmp12_ = length < 2;
						} else {
							_tmp12_ = FALSE;
						}
						if (_tmp12_) {
							const gchar* _tmp14_;
							gchar* _tmp15_;
							_tmp14_ = pw_name;
							_tmp15_ = g_strdup (_tmp14_);
							_g_free0 (target_user);
							target_user = _tmp15_;
						}
						_tmp16_ = pw_name;
						_tmp17_ = g_strdup (_tmp16_);
						_g_free0 (name);
						name = _tmp17_;
						_g_free0 (pw_name);
					}
				} else {
					PolkitIdentity* _tmp18_;
					_tmp18_ = ident;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, polkit_unix_group_get_type ())) {
						struct group* gwd = NULL;
						PolkitIdentity* _tmp19_;
						struct group* _tmp20_;
						struct group* _tmp21_;
						_tmp19_ = ident;
						_tmp20_ = getgrgid ((gid_t) polkit_unix_group_get_gid (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, polkit_unix_group_get_type (), PolkitUnixGroup)));
						gwd = _tmp20_;
						_tmp21_ = gwd;
						if (_tmp21_ != NULL) {
							struct group* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
							_tmp22_ = gwd;
							_tmp23_ = _tmp22_->gr_name;
							_tmp24_ = g_strdup_printf (_ ("Group: %s"), _tmp23_);
							_g_free0 (name);
							name = _tmp24_;
						}
					}
				}
				_tmp25_ = model;
				gtk_list_store_append (_tmp25_, &_tmp26_);
				iter = _tmp26_;
				_tmp27_ = model;
				_tmp28_ = iter;
				_tmp29_ = name;
				_tmp30_ = ident;
				gtk_list_store_set (_tmp27_, &_tmp28_, 0, "avatar-default-symbolic", 1, _tmp29_, 2, _tmp30_, -1);
				_tmp31_ = name;
				_tmp32_ = g_get_user_name ();
				if (g_strcmp0 (_tmp31_, _tmp32_) == 0) {
					active = length;
				}
				_tmp33_ = length;
				length = _tmp33_ + 1;
				_g_free0 (name);
			}
		}
	}
	_tmp34_ = self->priv->idents_combo;
	_tmp35_ = model;
	gtk_combo_box_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
	_tmp36_ = self->priv->idents_combo;
	gtk_combo_box_set_active (_tmp36_, active);
	if (length < 2) {
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		_tmp37_ = target_user;
		_tmp38_ = g_get_user_name ();
		if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
			GtkComboBox* _tmp39_;
			GtkComboBox* _tmp40_;
			_tmp39_ = self->priv->idents_combo;
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
			_tmp40_ = self->priv->idents_combo;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp40_, TRUE);
		} else {
			GtkComboBox* _tmp41_;
			_tmp41_ = self->priv->idents_combo;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp41_, FALSE);
		}
	}
	_g_free0 (target_user);
	_g_object_unref0 (model);
}

static void
_ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                            const gchar* text,
                                                                            gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_show_error ((AgWidgetsPolkitDialog*) self, text);
}

static void
_ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                  gboolean gained_authorization,
                                                                                  gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_session_completed ((AgWidgetsPolkitDialog*) self, gained_authorization);
}

static void
_ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                      const gchar* request,
                                                                      gboolean echo_on,
                                                                      gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_request ((AgWidgetsPolkitDialog*) self, request, echo_on);
}

static void
_ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                          const gchar* text,
                                                                          gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_show_info ((AgWidgetsPolkitDialog*) self, text);
}

static void
ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	PolkitIdentity* _tmp1_;
	const gchar* _tmp2_;
	PolkitAgentSession* _tmp3_;
	PolkitAgentSession* _tmp4_;
	gulong _tmp5_;
	PolkitAgentSession* _tmp6_;
	gulong _tmp7_;
	PolkitAgentSession* _tmp8_;
	gulong _tmp9_;
	PolkitAgentSession* _tmp10_;
	gulong _tmp11_;
	PolkitAgentSession* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ != NULL) {
		ag_widgets_polkit_dialog_deselect_session (self);
	}
	_tmp1_ = self->priv->pk_identity;
	_tmp2_ = self->priv->cookie;
	_tmp3_ = polkit_agent_session_new (_tmp1_, _tmp2_);
	_g_object_unref0 (self->priv->pk_session);
	self->priv->pk_session = _tmp3_;
	_tmp4_ = self->priv->pk_session;
	_tmp5_ = g_signal_connect_object (_tmp4_, "show-error", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error, self, 0);
	self->priv->error_signal_id = _tmp5_;
	_tmp6_ = self->priv->pk_session;
	_tmp7_ = g_signal_connect_object (_tmp6_, "completed", (GCallback) _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed, self, 0);
	self->priv->complete_signal_id = _tmp7_;
	_tmp8_ = self->priv->pk_session;
	_tmp9_ = g_signal_connect_object (_tmp8_, "request", (GCallback) _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request, self, 0);
	self->priv->request_signal_id = _tmp9_;
	_tmp10_ = self->priv->pk_session;
	_tmp11_ = g_signal_connect_object (_tmp10_, "show-info", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info, self, 0);
	self->priv->info_signal_id = _tmp11_;
	_tmp12_ = self->priv->pk_session;
	polkit_agent_session_initiate (_tmp12_);
}

static void
ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ != NULL) {
		PolkitAgentSession* _tmp1_;
		PolkitAgentSession* _tmp2_;
		PolkitAgentSession* _tmp3_;
		PolkitAgentSession* _tmp4_;
		_tmp1_ = self->priv->pk_session;
		g_signal_handler_disconnect (_tmp1_, self->priv->error_signal_id);
		_tmp2_ = self->priv->pk_session;
		g_signal_handler_disconnect (_tmp2_, self->priv->complete_signal_id);
		_tmp3_ = self->priv->pk_session;
		g_signal_handler_disconnect (_tmp3_, self->priv->request_signal_id);
		_tmp4_ = self->priv->pk_session;
		g_signal_handler_disconnect (_tmp4_, self->priv->info_signal_id);
		_g_object_unref0 (self->priv->pk_session);
		self->priv->pk_session = NULL;
	}
}

static void
ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	GtkEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	PolkitAgentSession* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ == NULL) {
		ag_widgets_polkit_dialog_select_session (self);
	}
	_tmp1_ = self->priv->password_entry;
	g_object_set (_tmp1_, "secondary-icon-name", "", NULL);
	_tmp2_ = self->priv->feedback_revealer;
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
	_tmp3_ = self->priv->pk_session;
	_tmp4_ = self->priv->password_entry;
	_tmp5_ = gtk_entry_get_text (_tmp4_);
	polkit_agent_session_response (_tmp3_, _tmp5_);
}

static void
ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->canceling = TRUE;
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ != NULL) {
		PolkitAgentSession* _tmp1_;
		_tmp1_ = self->priv->pk_session;
		polkit_agent_session_cancel (_tmp1_);
	}
	g_debug ("PolkitDialog.vala:236: Authentication cancelled");
	self->was_canceled = TRUE;
	self->priv->canceling = FALSE;
	g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
}

static void
ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	PolkitIdentity* _tmp9_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->idents_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (!_tmp2_) {
		ag_widgets_polkit_dialog_deselect_session (self);
		return;
	}
	_tmp3_ = self->priv->idents_combo;
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	model = _tmp5_;
	_tmp6_ = model;
	if (_tmp6_ == NULL) {
		_g_object_unref0 (model);
		return;
	}
	_tmp7_ = model;
	_tmp8_ = iter;
	gtk_tree_model_get (_tmp7_, &_tmp8_, 2, &_tmp9_, -1, -1);
	_g_object_unref0 (self->priv->pk_identity);
	self->priv->pk_identity = _tmp9_;
	ag_widgets_polkit_dialog_select_session (self);
	_g_object_unref0 (model);
}

static void
ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                  gboolean authorized)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
	if (!authorized) {
		_tmp0_ = TRUE;
	} else {
		GCancellable* _tmp1_;
		_tmp1_ = self->priv->cancellable;
		_tmp0_ = g_cancellable_is_cancelled (_tmp1_);
	}
	if (_tmp0_) {
		GtkEntry* _tmp2_;
		GtkEntry* _tmp3_;
		if (!self->priv->canceling) {
			ag_widgets_polkit_dialog_on_pk_show_error (self, _ ("Authentication failed. Please try again."));
		}
		ag_widgets_polkit_dialog_deselect_session (self);
		_tmp2_ = self->priv->password_entry;
		gtk_entry_set_text (_tmp2_, "");
		_tmp3_ = self->priv->password_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
		ag_widgets_polkit_dialog_select_session (self);
		return;
	} else {
		g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
	}
}

static void
ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                        const gchar* request,
                                        gboolean echo_on)
{
	GtkEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (request != NULL);
	_tmp0_ = self->priv->password_entry;
	gtk_entry_set_visibility (_tmp0_, echo_on);
	if (!g_str_has_prefix (request, "Password:")) {
		GtkLabel* _tmp1_;
		_tmp1_ = self->priv->password_label;
		gtk_label_set_label (_tmp1_, request);
	}
}

static void
ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                           const gchar* text)
{
	GtkEntry* _tmp0_;
	GtkLabel* _tmp1_;
	GtkRevealer* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->password_entry;
	g_object_set (_tmp0_, "secondary-icon-name", "dialog-error-symbolic", NULL);
	_tmp1_ = self->priv->password_feedback;
	gtk_label_set_label (_tmp1_, text);
	_tmp2_ = self->priv->feedback_revealer;
	gtk_revealer_set_reveal_child (_tmp2_, TRUE);
	ag_widgets_polkit_dialog_shake (self);
}

static void
ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	{
		gint n = 0;
		n = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint diff = 0;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = n;
					n = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(n < 10)) {
					break;
				}
				diff = 15;
				if ((n % 2) == 0) {
					diff = -15;
				}
				gtk_window_move ((GtkWindow*) self, x + diff, y);
				while (TRUE) {
					if (!gtk_events_pending ()) {
						break;
					}
					gtk_main_iteration ();
				}
				g_usleep ((gulong) 10000);
			}
		}
	}
	gtk_window_move ((GtkWindow*) self, x, y);
}

static void
ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                          const gchar* text)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	g_info ("PolkitDialog.vala:315: %s", text);
}

static gboolean
ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                         GdkEventKey* key)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	switch (key->keyval) {
		case GDK_KEY_KP_Enter:
		case GDK_KEY_Return:
		{
			ag_widgets_polkit_dialog_authenticate (self);
			result = GDK_EVENT_STOP;
			return result;
		}
		default:
		break;
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
ag_widgets_polkit_dialog_class_init (AgWidgetsPolkitDialogClass * klass,
                                     gpointer klass_data)
{
	ag_widgets_polkit_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AgWidgetsPolkitDialog_private_offset);
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) ag_widgets_polkit_dialog_real_show;
	G_OBJECT_CLASS (klass)->finalize = ag_widgets_polkit_dialog_finalize;
	ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL] = g_signal_new ("done", AG_WIDGETS_TYPE_POLKIT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
ag_widgets_polkit_dialog_instance_init (AgWidgetsPolkitDialog * self,
                                        gpointer klass)
{
	self->priv = ag_widgets_polkit_dialog_get_instance_private (self);
	self->was_canceled = FALSE;
	self->priv->pk_session = NULL;
	self->priv->pk_identity = NULL;
	self->priv->canceling = FALSE;
}

static void
ag_widgets_polkit_dialog_finalize (GObject * obj)
{
	AgWidgetsPolkitDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog);
	_g_object_unref0 (self->priv->pk_session);
	_g_object_unref0 (self->priv->pk_identity);
	_g_free0 (self->priv->cookie);
	_g_object_unref0 (self->priv->feedback_revealer);
	_g_object_unref0 (self->priv->password_label);
	_g_object_unref0 (self->priv->password_feedback);
	_g_object_unref0 (self->priv->password_entry);
	_g_object_unref0 (self->priv->idents_combo);
	G_OBJECT_CLASS (ag_widgets_polkit_dialog_parent_class)->finalize (obj);
}

GType
ag_widgets_polkit_dialog_get_type (void)
{
	static volatile gsize ag_widgets_polkit_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&ag_widgets_polkit_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AgWidgetsPolkitDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_widgets_polkit_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgWidgetsPolkitDialog), 0, (GInstanceInitFunc) ag_widgets_polkit_dialog_instance_init, NULL };
		GType ag_widgets_polkit_dialog_type_id;
		ag_widgets_polkit_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "AgWidgetsPolkitDialog", &g_define_type_info, 0);
		AgWidgetsPolkitDialog_private_offset = g_type_add_instance_private (ag_widgets_polkit_dialog_type_id, sizeof (AgWidgetsPolkitDialogPrivate));
		g_once_init_leave (&ag_widgets_polkit_dialog_type_id__volatile, ag_widgets_polkit_dialog_type_id);
	}
	return ag_widgets_polkit_dialog_type_id__volatile;
}

